//Parvulescu Floarea-Eugenia
//CA 331
//Proiect PM

#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>

/* joc de lumini cub intreg */
void fullCube()
{
	int i = 0;
	while (i <= 5)
	{		
		PORTD = 0x0f;
		PORTA = 0xff;
		PORTC = 0xff;
		
		_delay_ms(10000);
		
		PORTD = 0xf0;
		PORTA = 0x00;
		PORTC = 0x00;
		
		_delay_ms(10000);
		
		i++;
	}
}

/* joc de lumini pe diagonala */
void diagonala()
{
	int i = 0;
	while (i <= 2)
	{
		PORTA = 0x01;
		PORTC = 0x00;
		PORTD = 0x10;
		
		_delay_ms(225);
		
		PORTA = 0x20;
		PORTC = 0x00;
		PORTD = 0x20;
		
		_delay_ms(225);
		
		PORTA = 0x00;
		PORTC = 0x80;
		PORTD = 0x80;
		
		_delay_ms(225);
		
		PORTA = 0x04;
		PORTC = 0x00;
		PORTD = 0x40;
		
		_delay_ms(225);
		
		PORTD = 0x40;
		PORTA = 0x00;
		PORTC = 0x08;
		
		_delay_ms(225);

		PORTD = 0x40;
		PORTA = 0x00;
		PORTC = 0x10;
		
		_delay_ms(225);

		PORTD = 0x40;
		PORTA = 0x00;
		PORTC = 0x20;
		
		_delay_ms(225);

		PORTD = 0x80;
		PORTA = 0x00;
		PORTC = 0x01;
		
		_delay_ms(225);

		PORTD = 0x20;
		PORTA = 0x40;
		PORTC = 0x00;
		
		_delay_ms(225);

		PORTD = 0x10;
		PORTA = 0x08;
		PORTC = 0x00;
		
		_delay_ms(225);

		PORTD = 0x10;
		PORTA = 0x04;
		PORTC = 0x00;
		
		_delay_ms(225);

		PORTD = 0x10;
		PORTA = 0x02;
		PORTC = 0x00;
		
		_delay_ms(225);	
		
		i++;
	}
}

/* artificii */
void artificii()
{
	int i = 0;
	while (i <= 4)
	{
		PORTD=0x10;
		PORTA=0x00;
		PORTC=0x01;
		
		_delay_ms(2300);
		
		PORTD=0x20;
		PORTA=0x00;
		PORTC=0x01;
		
		_delay_ms(2900);
		
		PORTD=0x80;
		PORTA=0x00;
		PORTC=0x01;
		
		_delay_ms(3500);
		
		PORTD=0x40;
		PORTA=0x00;
		PORTC=0x01;
		
		_delay_ms(3500);
		
		PORTD=0x40;
		PORTA=0x50;
		PORTC=0x29;
		
		_delay_ms(3500);
		
		PORTD=0x80;
		PORTA=0x50;
		PORTC=0x28;
		
		_delay_ms(2900);
		
		PORTD=0x20;
		PORTA=0x50;
		PORTC=0x28;
		
		_delay_ms(2300);
		
		i++;
	}
}

/* stanga -> dreapta */
void stanga_dreapta()
{
	int i = 0;
	while (i <= 4)
	{
		PORTD=0xf0;
		PORTC=0x3c;
		PORTA=0x00;
		
		_delay_ms(2200);
		
		PORTD=0xf0;
		PORTC=0xc3;
		PORTA=0x00;
		
		_delay_ms(2200);
		
		PORTD=0xf0;
		PORTA=0xf0;
		PORTC=0x00;
		
		_delay_ms(2200);
		
		PORTD=0xf0;
		PORTA=0x0f;
		PORTC=0x00;
		
		_delay_ms(2200);
		
		PORTD=0xf0;
		PORTA=0xf0;
		PORTC=0x00;
		
		_delay_ms(2200);
		
		PORTD=0xf0;
		PORTC=0xc3;
		PORTA=0x00;
		
		_delay_ms(2200);
		
		i++;
	}
}

/* up */
void up()
{
	int i = 0;
	while (i <= 4)
	{
		PORTD=0x10;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(2700);
	
		PORTD=0x20;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(2700);
	
		PORTD=0x80;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(2700);
	
		PORTD=0x40;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(2700);
		
		PORTD=0x80;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(2700);
		
		PORTD=0x20;
		PORTA=0xff;
		PORTC=0xff;
		
		_delay_ms(2700);
		
		i++;
	}
}

/* circular */
void circular()
{
	int i = 0;
	while (i <= 14)
	{
		PORTD=0xf0;
		PORTA=0x48;
		PORTC=0x21;
		
		_delay_ms(1000);
	
		PORTD=0xf0;
		PORTA=0xc0;
		PORTC=0x03;
		
		_delay_ms(1000);
	
		PORTD=0xf0;
		PORTC=0xc0;
		PORTA=0x30;
		
		_delay_ms(1000);

		PORTD=0xf0;
		PORTC=0x84;
		PORTA=0x21;
		
		_delay_ms(1000);
	
		PORTD=0xf0;
		PORTC=0x88;
		PORTA=0x22;
		
		_delay_ms(1000);
	
		PORTD=0xf0;
		PORTC=0x11;
		PORTA=0x44;
		
		_delay_ms(1000);
		
		i++;
	}

}

void effect_1()
{
	PORTD=0xf0;
	int i = 0;
	while (i <= 3)
	{
		PORTA=0x00;
		PORTC=0x20;
		
		_delay_ms(1500);
		
		PORTA=0x00;
		PORTC=0x30;
		
		_delay_ms(1500);
		
		
		PORTA=0x00;
		PORTC=0x38;
		
		_delay_ms(1500);
		
		
		PORTA=0x00;
		PORTC=0x3c;
		_delay_ms(1200);
		
		
		PORTA=0x00;
		PORTC=0x7c;
		
		_delay_ms(1500);
		
		
		PORTA=0x00;
		PORTC=0xfc;
		
		_delay_ms(1500);
		
		
		PORTA=0x00;
		PORTC=0xfd;
		
		_delay_ms(1500);
		
		PORTA=0x00;
		PORTC=0xff;
		
		_delay_ms(1500);
		
		PORTC=0xff;
		PORTA=0x10;
		
		_delay_ms(1200);
		
		PORTC=0xff;
		PORTA=0x30;
		
		_delay_ms(1500);
		
		PORTC=0xff;
		PORTA=0x70;
		
		_delay_ms(1500);
		
		PORTC=0xff;
		PORTA=0xf0;
		
		_delay_ms(1500);
		
		
		PORTC=0xff;
		PORTA=0xf8;
		
		_delay_ms(1500);
		
		
		PORTC=0xff;
		PORTA=0xfc;
		
		_delay_ms(1500);
		
		
		PORTC=0xff;
		PORTA=0xfe;
		
		_delay_ms(1500);
		
		
		PORTC=0xff;
		PORTA=0xff;
		
		_delay_ms(1500);
		
		i++;
	}
}

void effect_2()
{
	int i = 0;
	while (i <= 2)
	{
		PORTD = 0x80;
		PORTA = 0xff;
		PORTC = 0xff;
		
		_delay_ms(225);

		PORTD = 0x40;
		PORTA = 0xff;
		PORTC = 0xff;
		
		_delay_ms(225);

		PORTD = 0x20;
		PORTA = 0xff;
		PORTC = 0xf;
		
		_delay_ms(225);

		PORTD = 0x10;
		PORTA = 0xff;
		PORTC = 0xff;
		
		_delay_ms(225);
		
		i++;
	}
}

void effect_3()
{
	int i, j;
	
	PORTD = 0x10;
	for (i = 0; i <= 3; i++)
	{
		PORTA = 0x01;
		PORTC = 0x00;
		
		for (j = 0; j <= 15; j++)
		{
			_delay_ms(650);
			PORTA = PORTA * 2;
		}
		
		PORTA = 0x00;
		PORTC = 0x01;
		
		for (j = 0; j <= 15; j++)
		{
			_delay_ms(650);
			PORTC = PORTC * 2;
		}
		
		PORTD = PORTD * 2;
	}
}

int main()
{
	//setez pinii corespunzatoare led-urilor ca output
	DDRA = 0xff;
	DDRC = 0xff;
	DDRD = 0xff;
	
	while (1)
	{
		fullCube();
	
		diagonala();
		
		effect_2();
		
		effect_3();
		
		artificii();
		
		stanga_dreapta();
		
		up();
		
		circular();
		
		effect_1();
	}
}